<template>
  <div class="Questionnairemanagement">
    <!-- 左侧栏 -->
    <div class="sidecolumn">
      <el-input placeholder="输入关键字进行过滤" v-model="filterText">
      </el-input>

      <el-tree
        class="filter-tree"
        :data="data"
        :props="defaultProps"
        default-expand-all
        :filter-node-method="filterNode"
        ref="tree"
      >
        <span class="custom-tree-node" slot-scope="{ node, data }">
          <span>{{ node.label }}</span>
          <span>
            <el-button type="text" size="mini" @click="() => append(data)">
              新增子级
            </el-button>
            <el-button
              type="text"
              size="mini"
              @click="() => remove(node, data)"
            >
              删除
            </el-button>
          </span>
        </span>
      </el-tree>
    </div>
    <!-- 中部数据 -->
    <div class="leftvlue">
      <div class="compile" v-for="item in list">
        <div class="compile-title">
          {{ item.name }}: <span>{{ item.uapiurl }}</span>
        </div>
        <div class="compile-value">
          <div class="compile-min" v-for="itea in item.value">
            <div>
              <el-input v-model="itea.value" placeholder="入参注解"></el-input>
            </div>
            <div>
              <el-input v-model="itea.name" placeholder="入参名"></el-input>
            </div>
            <div @click="drawer = true">展开下级</div>
          </div>
        </div>
      </div>
    </div>
    <el-drawer
      title="我是二级"
      direction="btt"
      :visible.sync="drawer"
      :with-header="false"
    >
      <div class="compile-value">
        <div class="compile-min" v-for="itea in 6">
          <div>
            <el-input v-model="input" placeholder="入参注解"></el-input>
          </div>
          <div>
            <el-input v-model="inputs" placeholder="入参名"></el-input>
          </div>
        </div>
      </div>
    </el-drawer>
  </div>
</template>

<script>
let id = 1000;
export default {
  name: "Editinterface",

  watch: {
    filterText(val) {
      this.$refs.tree.filter(val);
    },
  },

  data() {
    const data = [
      {
        id: 1,
        label: "患者服务中心",
        children: [
          {
            id: 4,
            label: "患者列表",
          },
          {
            id: 21,
            label: "患者服务",
          },
        ],
      },
      {
        id: 2,
        label: "一级 2",
        children: [
          {
            id: 5,
            label: "二级 2-1",
          },
          {
            id: 6,
            label: "二级 2-2",
          },
        ],
      },
      {
        id: 3,
        label: "一级 3",
        children: [
          {
            id: 7,
            label: "二级 3-1",
          },
          {
            id: 8,
            label: "二级 3-2",
          },
        ],
      },
    ];
    return {
      drawer: false,
      input: "",
      inputs: "",
      // 查询参数
      queryParams: {},
      currentRow: null, //选中行数据
      filterText: "",

      data: JSON.parse(JSON.stringify(data)),
      data: JSON.parse(JSON.stringify(data)),

      defaultProps: {
        children: "children",
        label: "label",
      },
      list: [
        {
          id: "23",
          name: "获取患者列表",
          uapiurl: "http://api",
          value: [
            { name: "children", value: "注解" },
            { name: "childrenone", value: "注解一" },
            { name: "childrentwo", value: "注解二" },
            { name: "childrenthree", value: "注解三" },
          ],
        },
        {
          id: "13",
          name: "获取患者详情",
          uapiurl: "http://api/xqq",
          value: [
            { name: "children", value: "注解" },
            { name: "childrenone", value: "注解一" },
            { name: "childrentwo", value: "注解二" },
            { name: "childrenthree", value: "注解三" },
            { name: "childrenthree", value: "注解四" },
          ],
        },
      ],
    };
  },
  watch: {},
  created() {},

  methods: {
    filterNode(value, data) {
      if (!value) return true;
      return data.label.indexOf(value) !== -1;
    },
    append(data) {
      const newChild = { id: id++, label: "子级", children: [] };
      if (!data.children) {
        this.$set(data, "children", []);
      }
      data.children.push(newChild);
    },

    remove(node, data) {
      const parent = node.parent;
      const children = parent.data.children || parent.data;
      const index = children.findIndex((d) => d.id === data.id);
      children.splice(index, 1);
    },
  },
};
</script>

<style lang="scss" scoped>
.Questionnairemanagement {
  display: flex;
}
.sidecolumn {
  width: 300px;
  min-height: 100vh;
  text-align: center;
  //   display: flex;
  margin-top: 20px;
  margin: 20px;
  padding: 10px;
  background: #edf1f7;
  border: 1px solid #dcdfe6;
  -webkit-box-shadow: 0 2px 4px 0 rgba(0, 0, 0, 0.12),
    0 0 6px 0 rgba(0, 0, 0, 0.04);
}
::v-deep .sidecolumn .el-tree {
  margin-top: 30px;
  background: none;
}

.leftvlue {
  //   display: flex;
  //   flex: 1;
  width: 80%;
  margin-top: 20px;
  //   margin: 20px;
  padding: 30px;
  background: #ffff;
  border: 1px solid #dcdfe6;
  -webkit-box-shadow: 0 2px 4px 0 rgba(0, 0, 0, 0.12),
    0 0 6px 0 rgba(0, 0, 0, 0.04);
  .compile {
    border: 1px solid #dcdfe6;
    padding: 15px;
    margin-top: 10px;
  }
}
.compile-value {
  display: flex;
  margin-top: 10px;

  .compile-min {
    border: 1px solid #dcdfe6;
    width: 150px;
    div {
      padding: 5px;
      text-align: center;
    }
  }
}
.compile-min div:nth-child(3) {
  padding: 0;
  margin: 5px;
  background: bisque;
  border-radius: 3px;
}
</style>
